package com.odfl.ws.odmove;

import java.net.URL;

import javax.xml.namespace.QName;
import javax.xml.transform.Source;
import javax.xml.ws.BindingProvider;
import javax.xml.ws.Dispatch;
import javax.xml.ws.Service;
import javax.xml.ws.soap.SOAPBinding;

import com.odfl.ws.odmove.accessorials.ModifyAccessorialsRequest;
import com.odfl.ws.odmove.guarantee.GuaranteeRequest;
import com.odfl.ws.odmove.modifytrailercount.ModifyTrailerCountRequest;
import com.odfl.ws.odmove.modifytrailercount.ModifyTrailerCountResponse;
import com.odfl.ws.odmove.reconsign.ReconsignRequest;
import com.odfl.ws.odmove.reconsign.ReconsignResponse;

public class ODMovePortProxy{

    protected Descriptor _descriptor;

    public class Descriptor {
        private com.odfl.ws.odmove.ODMoveService _service = null;
        private com.odfl.ws.odmove.ODMoveDelegate _proxy = null;
        private Dispatch<Source> _dispatch = null;

        public Descriptor() {
            init();
        }

        public Descriptor(URL wsdlLocation, QName serviceName) {
            _service = new com.odfl.ws.odmove.ODMoveService(wsdlLocation, serviceName);
            initCommon();
        }

        public void init() {
            _service = null;
            _proxy = null;
            _dispatch = null;
            _service = new com.odfl.ws.odmove.ODMoveService();
            initCommon();
        }

        private void initCommon() {
            _proxy = _service.getODMovePort();
        }

        public com.odfl.ws.odmove.ODMoveDelegate getProxy() {
            return _proxy;
        }

        public Dispatch<Source> getDispatch() {
            if (_dispatch == null ) {
                QName portQName = new QName("http://odmove.ws.odfl.com/", "ODMovePort");
                _dispatch = _service.createDispatch(portQName, Source.class, Service.Mode.MESSAGE);

                String proxyEndpointUrl = getEndpoint();
                BindingProvider bp = (BindingProvider) _dispatch;
                String dispatchEndpointUrl = (String) bp.getRequestContext().get(BindingProvider.ENDPOINT_ADDRESS_PROPERTY);
                if (!dispatchEndpointUrl.equals(proxyEndpointUrl))
                    bp.getRequestContext().put(BindingProvider.ENDPOINT_ADDRESS_PROPERTY, proxyEndpointUrl);
            }
            return _dispatch;
        }

        public String getEndpoint() {
            BindingProvider bp = (BindingProvider) _proxy;
            return (String) bp.getRequestContext().get(BindingProvider.ENDPOINT_ADDRESS_PROPERTY);
        }

        public void setEndpoint(String endpointUrl) {
            BindingProvider bp = (BindingProvider) _proxy;
            bp.getRequestContext().put(BindingProvider.ENDPOINT_ADDRESS_PROPERTY, endpointUrl);

            if (_dispatch != null ) {
                bp = (BindingProvider) _dispatch;
                bp.getRequestContext().put(BindingProvider.ENDPOINT_ADDRESS_PROPERTY, endpointUrl);
            }
        }

        public void setMTOMEnabled(boolean enable) {
            SOAPBinding binding = (SOAPBinding) ((BindingProvider) _proxy).getBinding();
            binding.setMTOMEnabled(enable);
        }
    }

    public ODMovePortProxy() {
        _descriptor = new Descriptor();
        _descriptor.setMTOMEnabled(false);
    }

    public ODMovePortProxy(URL wsdlLocation, QName serviceName) {
        _descriptor = new Descriptor(wsdlLocation, serviceName);
        _descriptor.setMTOMEnabled(false);
    }

    public Descriptor _getDescriptor() {
        return _descriptor;
    }

    public BookResponse bookMove(BookRequest arg0) {
        return _getDescriptor().getProxy().bookMove(arg0);
    }

    public BookResponse changeMoveDate(ChangeDateRequest arg0) {
        return _getDescriptor().getProxy().changeMoveDate(arg0);
    }

    public HomeMovingResponse changeConsigneeAddress(ChangeAddressRequest arg0) {
        return _getDescriptor().getProxy().changeConsigneeAddress(arg0);
    }

    public HomeMovingResponse cancelMove(CancelMoveRequest arg0) {
        return _getDescriptor().getProxy().cancelMove(arg0);
    }

    public HomeMovingResponse guaranteeMove(GuaranteeRequest arg0) {
        return _getDescriptor().getProxy().guaranteeMove(arg0);
    }

    public HomeMovingResponse modifyAccessorials(ModifyAccessorialsRequest arg0) {
        return _getDescriptor().getProxy().modifyAccessorials(arg0);
    }

    public ReconsignResponse reconsign(ReconsignRequest arg0) {
        return _getDescriptor().getProxy().reconsign(arg0);
    }

    public ModifyTrailerCountResponse modifyTrailerCount(ModifyTrailerCountRequest arg0) {
        return _getDescriptor().getProxy().modifyTrailerCount(arg0);
    }

}