package examples;

import java.rmi.RemoteException;
import java.util.List;
import java.util.Map;

import javax.xml.ws.BindingProvider;

import org.apache.log4j.Logger;

import com.odfl.ws.odmove.ODMovePortProxy;

public abstract class AbstractExample {

	private static final Logger LOG = Logger.getLogger(AbstractExample.class);
	
	protected static final String PRO_NUMBER = "77741860132";
	
	public static final String LIVE_URL = "https://www.odfl.com/wsODMove_v2/ODMoveService";
	// public static final String LIVE_URL = "https://localhost:9444/wsODMove_v2/ODMoveService";
	public ODMovePortProxy service = new ODMovePortProxy();

	// DEV:  This static initializer is only for odfl internal testing
//	static {
//	    //for localhost testing only -- pass anything against localhost
//	    javax.net.ssl.HttpsURLConnection.setDefaultHostnameVerifier(
//	    new javax.net.ssl.HostnameVerifier(){
// 
//	        public boolean verify(String hostname,
//	                javax.net.ssl.SSLSession sslSession) {
//	            if (hostname.equals("localhost")) {
//	                return true;
//	            }
//	            return false;
//	        }
//	    });
//	}

	public void commonExecute() throws Exception{
		setupSystem();
		service._getDescriptor().setEndpoint(LIVE_URL);
		execute();
	}

	public void setupSystem(){
		
		Map<String,Object> requestCtx = ((BindingProvider)service._getDescriptor().getProxy()).getRequestContext();
		
		// TODO: Insert your username/password for basic authentication
		requestCtx.put(BindingProvider.USERNAME_PROPERTY, "*******");	
		requestCtx.put(BindingProvider.PASSWORD_PROPERTY, "*******");	

	}

	protected abstract void execute() throws RemoteException;
	
	protected void outputErrors(List<String> errors) {
		LOG.info("Error(s): ");
		for (String error : errors) {
			LOG.info(error);
		}		
	}
}
