package examples;

import java.rmi.RemoteException;
import java.util.Iterator;

import org.apache.log4j.Logger;

import com.odfl.ws.odmove.Address;
import com.odfl.ws.odmove.BookRequest;
import com.odfl.ws.odmove.BookResponse;


public class BookMoveGoodData extends AbstractExample{
	
	private BookRequest request = new BookRequest();
	private Address billAddr = new Address();
	private Address orgAddr = new Address();
	private Address destAddr = new Address();
	
	private static final Logger LOG = Logger.getLogger(BookMoveGoodData.class);
	
	public static void main(String[] args){
		BookMoveGoodData gd = new BookMoveGoodData();
		gd.setUp();
		
		try {
			gd.commonExecute();
		} catch (Exception e) {
			LOG.error(e);
		}
	}
	
	public void setUp(){
		orgAddr.setAddress1("123 Origin Test");
		orgAddr.setAddress2("#1");
		orgAddr.setCity("Thomasville");
		orgAddr.setCountry("USA");
		orgAddr.setName("Wes Miller");
		orgAddr.setPostalCode("27360");
		orgAddr.setState("NC");
		destAddr.setAddress1("987 Destination Test");
		destAddr.setCity("Beverly Hills");
		destAddr.setCountry("USA");
		destAddr.setName("Sandi Street");
		destAddr.setPostalCode("90210");
		destAddr.setState("CA");
		billAddr = orgAddr;
		request.setBillingAddress(billAddr);
		request.setOriginAddress(orgAddr);
		request.setDestinationAddress(destAddr);
		request.setBillingPhone1("1234567890");
		request.setBillingPhone2("9987654321");
		request.setReferenceNumber("27245210");
		request.setEmail("email@email.com"); 	//email used to get quote
		request.setPaymentType("MO");
		request.setChangeDate("20140326");			//insert valid(yyyymmdd) date to change move date from what's on quote
		request.setAccCodes("");
		request.setOrgDropTime("0");		//insert valid military time (0800-1600) (0800 = 8:00am, 1600 = 4:00pm)
	}
	

	
	
	protected void execute() throws RemoteException{
		BookResponse response = service.bookMove(request);
		if(response.isSuccess()){
			LOG.info("Success:");
			LOG.info("Pro #: "+response.getProNumber());
			LOG.info("Coupon Amount: "+response.getCouponAmount());
		}
		else{
			LOG.info("Error: ");
			Iterator<String> it = response.getErrorMessages().iterator();
			while(it.hasNext()){
				LOG.info(it.next());
			}
		}
	}
}
