package examples;

import java.rmi.RemoteException;

import org.apache.log4j.Logger;

import com.odfl.ws.odmove.CancelMoveRequest;
import com.odfl.ws.odmove.HomeMovingResponse;


public class CancelExample extends AbstractExample {
	
	private static final Logger LOG = Logger.getLogger(CancelExample.class);
	
	public static void main(String[] args){
		CancelExample example = new CancelExample();
		
		try {
			example.commonExecute();
		} catch (Exception e) {
			e.printStackTrace();
			LOG.error(e);
		}
	}
	
	
	protected void execute() throws RemoteException {
		
		CancelMoveRequest request = new CancelMoveRequest();
		request.setProNumber(PRO_NUMBER);
		
		HomeMovingResponse response = service.cancelMove(request);
		
		if (response.isSuccess()) {
			LOG.info("Success!");
		} else {
			outputErrors(response.getErrorMessages());
		}
			
	}
}
