package examples;

import java.rmi.RemoteException;
import java.util.Iterator;

import org.apache.log4j.Logger;

import com.odfl.ws.odmove.ChangeAddressRequest;
import com.odfl.ws.odmove.HomeMovingResponse;

public class ChangeConsigneeAddressGoodData extends AbstractExample{
	
	private ChangeAddressRequest request = new ChangeAddressRequest();
	private static final Logger LOG = Logger.getLogger(ChangeDateGoodData.class);
	
	public static void main(String[] args){
		ChangeConsigneeAddressGoodData gd = new ChangeConsigneeAddressGoodData();
		gd.setUp();
		try {
			gd.commonExecute();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			LOG.error("Error: ", e);
		}
	}
	
	public void setUp(){
		request.setAddress1("Test 20130401");
		request.setAddress2("Time 1043");
		request.setReferenceNumber("24006696");
	}
	
	protected void execute() throws RemoteException{
		HomeMovingResponse response = service.changeConsigneeAddress(request);
		if(response.isSuccess()){
			LOG.info("Success! Consignee address has changed.");
		}
		else{
			LOG.info("Error: ");
			Iterator<String> it = response.getErrorMessages().iterator();
			while(it.hasNext()){
				LOG.info(it.next());
			}
		}
	}
}
