package examples;

import java.rmi.RemoteException;

import javax.xml.datatype.DatatypeConfigurationException;

import org.apache.log4j.Logger;

import com.odfl.ws.odmove.HomeMovingResponse;
import com.odfl.ws.odmove.guarantee.GuaranteeRequest;


public class GuaranteeMoveExample extends AbstractExample {
	
	private static final Logger LOG = Logger.getLogger(GuaranteeMoveExample.class);
	
	public static void main(String[] args){
		GuaranteeMoveExample example = new GuaranteeMoveExample();
		
		try {
			example.commonExecute();
		} catch (Exception e) {
			e.printStackTrace();
			LOG.error(e);
		}
	}
	
	
	protected void execute() throws RemoteException {
		
		GuaranteeRequest request = new GuaranteeRequest();

		try {
			request.setSpotDate(Utils.stringToXMLGregorianCalendar("2014-03-24"));
			request.setPickupDate(Utils.stringToXMLGregorianCalendar("2014-03-25"));
			request.setDeliveryDate(Utils.stringToXMLGregorianCalendar("2014-03-29"));

			// We need this is there is a second trailer, otherwise, leave it out
			// -------------------------------------------------------------------
			// request.setSpotDate(Utils.stringToXMLGregorianCalendar("20140424"));
			// request.setPickupDate(Utils.stringToXMLGregorianCalendar("20140425"));
			// request.setDeliveryDate(Utils.stringToXMLGregorianCalendar("20140429"));
			
			request.setProNumber(PRO_NUMBER);
			HomeMovingResponse response = service.guaranteeMove(request);
			
			if (response.isSuccess()) {
				LOG.info("Success!");
			} else {
				outputErrors(response.getErrorMessages());
			}
			
		} catch (DatatypeConfigurationException e) {
			
			LOG.error(e);
		}


	}
}
