package examples;

import java.rmi.RemoteException;

import org.apache.log4j.Logger;

import com.odfl.ws.odmove.HomeMovingResponse;
import com.odfl.ws.odmove.accessorials.ModifyAccessorialsRequest;


public class ModifyAccessorialsExample extends AbstractExample {
	
	private static final Logger LOG = Logger.getLogger(ModifyAccessorialsExample.class);
	
	public static void main(String[] args){
		ModifyAccessorialsExample example = new ModifyAccessorialsExample();
		
		try {
			example.commonExecute();
		} catch (Exception e) {
			e.printStackTrace();
			LOG.error(e);
		}
	}
	
	
	protected void execute() throws RemoteException {
		
		ModifyAccessorialsRequest request = new ModifyAccessorialsRequest();

		/*
		 * Example codes
		 * HH5  code for straps
		 * HHT  code for hand truck
		 * HGO  code for drop trailer time at origin with 2 hour window	**Used with origin drop off time**
		 * HHL  code for live load
		 * HHU  code for live unload
		 * STR  code for storage
		 * 
		 * If you want to modify more than one accessorial in a single request, simply add multiple codes
		 * to the appropriate string.  (e.g. "HH5HHT")
		 */
		request.setAddAccessorials("HH5HHL");
		// request.setRemoveAccessorials("HH5HHL");
		request.setGuaranteeTime(10);
		request.setProNumber(PRO_NUMBER);
		HomeMovingResponse response = service.modifyAccessorials(request);
		
		if (response.isSuccess()) {
			LOG.info("Success!");
		} else {
			outputErrors(response.getErrorMessages());
		}
	}
}
