package examples;

import java.rmi.RemoteException;

import org.apache.log4j.Logger;

import com.odfl.ws.odmove.modifytrailercount.ModifyTrailerCountRequest;
import com.odfl.ws.odmove.modifytrailercount.ModifyTrailerCountResponse;


public class ModifyTrailerCountExample extends AbstractExample {
	
	private static final Logger LOG = Logger.getLogger(ModifyTrailerCountExample.class);
	
	public static void main(String[] args){
		ModifyTrailerCountExample example = new ModifyTrailerCountExample();
		
		try {
			example.commonExecute();
		} catch (Exception e) {
			e.printStackTrace();
			LOG.error(e);
		}
	}
	
	
	protected void execute() throws RemoteException {
		
		ModifyTrailerCountRequest request = new ModifyTrailerCountRequest();
		
		// Valid values are "A" for Add and "R" for remove. 
		request.setActionType("A");
		request.setFeetRequiredOnNewTrailer(10);
		request.setProNumber(PRO_NUMBER);
		ModifyTrailerCountResponse response = service.modifyTrailerCount(request);
		
		if (response.isSuccess()) {
			LOG.info("Success:");
			if ("A".equals(request.getActionType())) {
				LOG.info("Pro# for second trailer: "+response.getProNumber());
			}
		} else {
			outputErrors(response.getErrorMessages());
		}
	}
}
