package examples;

import java.rmi.RemoteException;

import org.apache.log4j.Logger;

import com.odfl.ws.odmove.Address;
import com.odfl.ws.odmove.reconsign.ReconsignRequest;
import com.odfl.ws.odmove.reconsign.ReconsignResponse;


public class ReconsignExample extends AbstractExample {
	
	private static final Logger LOG = Logger.getLogger(ReconsignExample.class);
	
	public static void main(String[] args){
		ReconsignExample example = new ReconsignExample();
		
		try {
			example.commonExecute();
		} catch (Exception e) {
			e.printStackTrace();
			LOG.error(e);
		}
	}
	
	
	protected void execute() throws RemoteException {
		
		ReconsignRequest request = new ReconsignRequest();

		Address destAddr = new Address();
		destAddr.setAddress1("987 Reconsign Test");
		destAddr.setCity("Beverly Hills");
		destAddr.setCountry("USA");
		destAddr.setName("Mr. Reconsign");
		destAddr.setPostalCode("90212");
		destAddr.setState("CA");
		
		request.setAddress(destAddr);
		request.setProNumber(PRO_NUMBER);
		
		ReconsignResponse response = service.reconsign(request);
		
		if (response.isSuccess()) {
			LOG.info("Success!");
			LOG.info("Reconsignment amount: " + response.getReconsignmentAmount());
		} else {
			outputErrors(response.getErrorMessages());
		}
			
	}
}
