package examples;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.GregorianCalendar;

import javax.xml.datatype.DatatypeConfigurationException;
import javax.xml.datatype.DatatypeFactory;
import javax.xml.datatype.XMLGregorianCalendar;

public class Utils {

	// public static final String AS400_DATE_FORMAT_STRING = "yyyyMMdd";
	public static final SimpleDateFormat ISO_FORMAT = new SimpleDateFormat("yyyy-MM-dd");
	
	public static XMLGregorianCalendar dateToXMLGregorianCalendar(Date date) 
			throws DatatypeConfigurationException {
		GregorianCalendar gc = (GregorianCalendar) GregorianCalendar.getInstance();
		gc.setTime(date);
		return DatatypeFactory.newInstance().newXMLGregorianCalendar(gc);
	}
	
	public static XMLGregorianCalendar stringToXMLGregorianCalendar(String date) 
			throws DatatypeConfigurationException {
		try {
			return dateToXMLGregorianCalendar(ISO_FORMAT.parse(date));
		} catch (ParseException e) {
			throw new DatatypeConfigurationException(e);
		}
	}
	
	
}
